*-----------------------------------------------------------------------------
*  members.prg, hacked from taiupd.prg
*  - creates members.lst from dues.dbf, prints kenshiid
*    to mks sort on rank: sort -t # -k 1.35 -r kumi.1 >kumi.2
*    -t #           makes whole line one field, 35 means start at col 35
*    -k 1.35,1.40   specifies col 35-40 range
*    -r             reverse sort
*  - uses kenshi.mem: nxtkid, ., refage, adultBD, etc
*  - Kk: must manually change title and kenshi list generator (use Mm instead)
*------------------------------------------------------------------------------

clear all
set century on
set talk off
set status on
set bell off

* public variables (saved/restored)
public  refdate  && reference for duespaid filter (eg 1st of the year)
public  refage   && reference for age calculation (eg shinkyu date)
public  newpaid  && new duespaid date for updating records
public  adultBD  && adult birthdate
public  kidBD    && kid birthdate (under 14)
public  nxtkid   && next available kenshiid
public  option   && menu selection

restore from kenshi
* refdate = ctod('1/1/96')
* refage  = ctod('7/15/97')
* newpaid = ctod('3/4/97')
* adultBD = ctod('7/15/79')
* kidBD = ctod('7/15/83')
* nxtkid = 601503
* option = ' '

* private variables (not saved/restored)
private title    && name of tournament
private promptln && end of menu display
private filt     && non-blank taikai field filter
private current  && current kenshi one-line summary
private ans      && user answer

private dojo     && dojoMenu args: dojo abbreviation
private dojname  &&   dojo name
private did      &&   dojofedid
private ad       &&   all vs single dojo

private rp       && for update: refdate
private ra       &&   refage
private dp       &&   duespaid
private kid      &&   kenshiid
private u1st     &&   usefirst
private lst      &&   lastname
private fst      &&   firstname
private mid      &&   midname
private bd       &&   birthdate
private h        &&   height string
private ht       &&   height
private wt       &&   weight
private sx       &&   sex
private r        &&   rank string
private rank     &&   rankcode
private rd       &&   rankdate
private rp       &&   rankplace
private doj      &&   
private x        &&   

private yr       && scratch: year
private mo       &&   month
private tmpno    &&   recno
private tmpname  &&   lastname for search
private tmpdate  &&   birthdate (1st of month)
private tmpdate1 &&   birthdate (1st of next month)

select b
use usadojo
set safety off
index on dojofedid to dojofedid
set safety on
goto top
select a
use dues
set relation to dojofedid into usadojo
goto top
set procedure to dfsubs

* initialize variables
*title= '2001 So Calif Kendo Championships'
title= 'Next taikai'
option = '#'     && to paint menu first time
filt = 'w'       && f=taikai filtered
current = ' '
dojo = 'all'
dojname = ' '
did = 6001
ad = .T.
x = ' '
promptln = 0
         ans = 'N'
         rp = refdate
         ra = refage
         @ promptln,0 clear
         @ promptln,1    say 'Reference for duespaid filter:'
         @ promptln+1,1  say 'Reference for age calculation:'
         @ promptln+1,43 say '(adult='+dtoc(adultBD)+', kid='+dtoc(kidBD)+')'
         do while .not. ans $ 'YyQq'
            @ promptln  ,32 get rp picture '99/99/9999'
            @ promptln+1,32 get ra picture '99/99/9999'
            read
            @ promptln+4,0  clear
            wait ' Update (Y/N/Q)? ' to ans
         enddo
         if ans $ 'Yy'
            refdate = rp
            refage = ra
            yr = year(refage)
            yr = yr - 18
            adultBD = ctod(left(dtoc(refage),6) + ltrim(str(yr)))
            yr = yr + 4
            kidBD = ctod(left(dtoc(refage),6) + ltrim(str(yr)))
            option = '#'
         endif

         select b
         use usadojo index usadojo
         goto top
         select a
         use dues
         set relation to dojofedid into usadojo
         goto top

         ? 'Writing MEMBERS.LST'
         set alternate to members.lst
         set alternate on
         set filter to duespaid > refdate
         goto top
         tot = 0
         delim = 4000

         t1 = '  KENSHIID DOJO NAME                        RANK  AGE G'
         t2 = '  -------- ---- -------------------------- ------ --- -'
*                2        1    6                          3 5 7   1  4
*              0         10        20        30        40        50
         ? t1
         ? t2
         do while .not. eof()
            && kenshid
            x = str(kenshiid)

            && dojo
            x = x + ' ' + trim(b->abbrev)
            && name
            do while len(x)<16
               x = x + ' '
            enddo
            if usefirst
               x = x + upper(trim(lastname))+', '+trim(firstname)
            else
               x = x + upper(trim(lastname))+', '+trim(midname)
            endif
            && rank
            do while len(x)<43
               x = x + ' '
            enddo
            do decRank with rankcode,r
            if rankcode = 301  && {don't print year rcvd for 0 KYU}
               x = x + '  '+r
            else
               x = x + r
               do while len(x)<47
                  x = x + ' '
               enddo
               if year(rankdate) >= 2010
                  x = x + ltrim(str(year(rankdate)-2000))
               else
                  if year(rankdate) >= 2000
                     x = x + '0'+ltrim(str(year(rankdate)-2000))
                  else
                     if year(rankdate) > 1900
                        x = x + ltrim(str(year(rankdate)-1900))
                     endif
                  endif
               endif
            endif
            && age
            do while len(x)<51
               x = x + ' '
            enddo
            age = year(refage) - year(birthdate) 
            bdThisYr=ctod(left(dtoc(birthdate),6)+ltrim(str(year(refage))))
            if bdThisYr > refage
               age = age - 1 
            endif
            if age > 0 .and. age < 100
               set century off
               set century on
               if age < 10
                  x = x + ' '+ltrim(str(age))
               else
                  x = x + ltrim(str(age))
               endif
            endif
            && sex
            do while len(x)<54
               x = x + ' '
            enddo
            x = x + sex

            && print line
            ? x
            skip
         enddo
         ? ' '
         close all

*-------------
* termination
*-------------
set safety off
* release all && release private variables
* note: comment out above because restore doesn't preserve public?
save to kenshi
set safety on
close all
set talk on
set status on
set echo off
on escape

quit && to DOS

